<?php

class CreateTableFactoryLevelsLang extends Doctrine_Migration_Base
{
    private $_tableName = 'factory_levels_lang';
    
    function up()
    {
        $this->createTable($this->_tableName, array(
            'id' => array(
                'type' => 'integer',
                'primary' => true,
                'autoincrement' => true,
            ),
            'factory_level_id' => array(
                'type' => 'integer',
                'notnull' => true,
            ),
            'lang_id' => array(
                'type' => 'integer',
                'notnull' => true,
            ),
            'name' => array(
                'type' => 'character varying(256)',
                'notnull' => false,
            ),
            'description' => array(
                'type' => 'text',
                'notnull' => false,
            ),
        ));
    }

    public function postUp()
    {
        Doctrine_Manager::connection()->exec('ALTER TABLE ' . $this->_tableName . ' ALTER COLUMN lang_id SET DEFAULT 1');
	}

    public function down()
    {
        $this->dropTable($this->_tableName);
    }
}

?>
